// SIP/2.0 403 Forbidden
// Via: SIP/2.0/UDP 127.0.1.1:5060;rport=65476;received=185.179.142.180;branch=z9hG4bK-457882779
// Call-ID: 2112593047
// From: "6666666667" <sip:6666666667@xinu.me>;tag=363636363636363636370133303731363137323935
// To: "6666666667" <sip:6666666667@xinu.me>;tag=z9hG4bK-457882779
// CSeq: 1 REGISTER
// Server: Asterisk PBX 18.9.0
// Content-Length:  0

#[derive(Debug)]
pub struct Forbidden {
    pub command: String,                 // SIP/2.0 403 Forbidden
    pub via: String, // SIP/2.0/UDP 127.0.1.1:5061;branch=z9hG4bK-487618168;rport
    pub call_id: Option<String>, // Call-ID: 447615548427934163033914
    pub from: String, // "sipvicious"<sip:100@1.1.1.1>;tag=37663030303030313133633401393537303038303638
    pub to: String,   // "sipvicious"<sip:100@1.1.1.1>
    pub cseq: String, // 1 OPTIONS
    pub server: Option<String>, // Asterisk PBX 18.9.0
    pub content_length: Option<i32>, // 0
}

#[allow(dead_code)]
impl Forbidden {
    pub fn serialize(&self) -> Vec<u8> {
        let mut preout = format!(
            "{}
Via: {}
Call-ID: {}
From: {}
To: {}
CSeq: {}
Server: {}
Content-Length: {}",
            &self.command,
            &self.via,
            &self.call_id.as_ref().unwrap(),
            &self.from,
            &self.to,
            &self.cseq,
            &self.server.as_ref().unwrap(),
            &self.content_length.unwrap().to_string(),
        );
        preout.push_str("\n\n\n");
        // println!("{}", preout);
        preout.as_bytes().to_vec()
    }
}
