// Mandatory: To, From, CSeq, Call-ID, Max-Forwards, and Via;
// Para enviar respostas xenéricas
// un "vale para todo"
#[derive(Debug)]
pub struct Generic {
    pub command: String,
    pub to: String,
    pub from: String,
    pub cseq: String,
    pub call_id: String,
    pub max_forwards: i32,
    pub via: String,
    pub server: Option<String>,
    pub content_length: Option<i32>,
}

impl Generic {
    pub fn serialize(&self) -> Vec<u8> {
        let mut preout = format!(
            "{}
Via: {}
Call-ID: {}
Max-Forwards: {}
From: {}
To: {}
CSeq: {}
Server: {}
Content-Length: {}",
            &self.command,
            &self.via,
            &self.call_id,
            &self.max_forwards,
            &self.from,
            &self.to,
            &self.cseq,
            &self.server.as_ref().unwrap(),
            &self.content_length.unwrap().to_string(),
        );
        preout.push_str("\n\n\n");
        // println!("{}", preout);
        preout.as_bytes().to_vec()
    }
}
