/*
SIP/2.0 404 Not Found
Via: SIP/2.0/UDP 127.0.1.1:5060;rport=65476;received=185.179.142.180;branch=z9hG4bK-3692480612
Call-ID: 953932568039675157936807
From: "sipvicious" <sip:100@1.1.1.1>;tag=6239623338663563313363370134323538333932373936
To: "sipvicious" <sip:100@1.1.1.1>;tag=z9hG4bK-3692480612
CSeq: 1 OPTIONS
Accept: application/xpidf+xml, application/cpim-pidf+xml, application/dialog-info+xml, application/simple-message-summary, application/pidf+xml, application/pidf+xml, application/dialog-info+xml, application/s
ple-message-summary, application/sdp, message/sipfrag;version=2.0
Allow: OPTIONS, REGISTER, SUBSCRIBE, NOTIFY, PUBLISH, INVITE, ACK, BYE, CANCEL, UPDATE, PRACK, MESSAGE, REFER
Supported: 100rel, timer, replaces, norefersub
Accept-Encoding: identity
Accept-Language: en
Server: Asterisk PBX 18.9.0
Content-Length:  0
*/
#[derive(Debug)]
pub struct NotFoundPacket {
    pub command: String,                 // SIP/2.0 404 Not Found
    pub via: String, // SIP/2.0/UDP 127.0.1.1:5061;branch=z9hG4bK-487618168;rport
    pub call_id: Option<String>, // Call-ID: 447615548427934163033914
    pub from: String, // "sipvicious"<sip:100@1.1.1.1>;tag=37663030303030313133633401393537303038303638
    pub to: String,   // "sipvicious"<sip:100@1.1.1.1>
    pub cseq: String, // 1 OPTIONS
    pub accept: Option<String>, // application/sdp
    pub allow: Option<String>, // OPTIONS, REGISTER, SUBSCRIBE, NOTIFY, PUBLISH, INVITE...
    pub supported: Option<String>, // 100rel, timer, replaces, norefersub
    pub accept_encoding: Option<String>, // identity
    pub accept_language: Option<String>, // en
    pub server: Option<String>, // Asterisk PBX 18.9.0
    pub content_length: Option<i32>, // 0
}

impl NotFoundPacket {
    pub fn serialize(&self) -> Vec<u8> {
        let mut preout = format!(
            "{}
Via: {}
Call-ID: {}
From: {}
To: {}
CSeq: {}
Accept: {}
Allow: {}
Supported: {}
Accept-Encoding: {}
Accept-Language: {}
Server: {}
Content-Length: {}",
            &self.command,
            &self.via,
            &self.call_id.as_ref().unwrap(),
            &self.from,
            &self.to,
            &self.cseq,
            &self.accept.as_ref().unwrap(),
            &self.allow.as_ref().unwrap(),
            &self.supported.as_ref().unwrap(),
            &self.accept_encoding.as_ref().unwrap(),
            &self.accept_language.as_ref().unwrap(),
            &self.server.as_ref().unwrap(),
            &self.content_length.unwrap().to_string(),
        );
        preout.push_str("\n\n");
        // println!("{}", preout);
        preout.as_bytes().to_vec()
    }
}
