/*
SIP/2.0 401 Unauthorized
Via: SIP/2.0/UDP 127.0.1.1:5060;rport=65476;received=185.179.142.180;branch=z9hG4bK-569407384
Call-ID: 1283048503
From: "6666666666" <sip:6666666666@xinu.me>;tag=36363636363636363636013930343637323738
To: "6666666666" <sip:6666666666@xinu.me>;tag=z9hG4bK-569407384
CSeq: 1 REGISTER
WWW-Authenticate: Digest realm="asterisk",nonce="1670408728/f2288b61ff3e1c5a8fbad2282734a53b",opaque="37899594559ff83d",algorithm=md5,qop="auth"
Server: Asterisk PBX 18.9.0
Content-Length:  0
*/
#[derive(Debug)]
pub struct Unauthorized {
    pub command: String,                 // SIP/2.0 401 Unauthorized
    pub via: String, // SIP/2.0/UDP 127.0.1.1:5061;branch=z9hG4bK-487618168;rport
    pub call_id: Option<String>, // Call-ID: 447615548427934163033914
    pub from: String, // "sipvicious"<sip:100@1.1.1.1>;tag=37663030303030313133633401393537303038303638
    pub to: String,   // "sipvicious"<sip:100@1.1.1.1>
    pub cseq: String, // 1 OPTIONS
    pub www_authenticate: Option<String>, // WWW-Authenticate: Digest realm="asterisk",nonce="1670408728/f2288b61ff3e1c5a8fbad2282734a53b",opaque="37899594559ff83d",algorithm=md5,qop="auth"
    pub server: Option<String>, // Asterisk PBX 18.9.0
    pub content_length: Option<i32>, // 0
}

impl Unauthorized {
    pub fn serialize(&self) -> Vec<u8> {
        let mut preout = format!(
            "{}
Via: {}
Call-ID: {}
From: {}
To: {}
CSeq: {}
WWW-Authenticate: {}
Server: {}
Content-Length: {}",
            &self.command,
            &self.via,
            &self.call_id.as_ref().unwrap(),
            &self.from,
            &self.to,
            &self.cseq,
            &self.www_authenticate.as_ref().unwrap(),
            &self.server.as_ref().unwrap(),
            &self.content_length.unwrap().to_string(),
        );
        preout.push_str("\n\n\n");
        // println!("{}", preout);
        preout.as_bytes().to_vec()
    }
}
